-- Version: 0.5.5

math.randomseed(os.time())

-- Libraries
require ('libs/camera')
anim8 = require 'libs/anim8'

require "libs/stateManager"
require "libs/lovelyMoon"

-- Gamestates
require("states/introState")
require("states/menuState")
require("states/gameState")
require("states/steamState")

-- Other Files
require "terrain/generation"
require "terrain/collisions"

function love.load()
	-- Settings
	size_of_map_width  = 600
	size_of_map_height = 100
		
	-- Gamestates
	addState(IntroState, "intro")
	addState(MenuState, "menu")
	addState(GameState, "game")
	addState(SteamState, "steam")
	
	-- Enables the Gamestate
	enableState("intro")
end

function love.draw()
	lovelyMoon.draw()
end

function love.update(dt)
	lovelyMoon.update(dt)
end

function love.keypressed(key)
	lovelyMoon.keypressed(key)
end

function love.mousepressed( x, y, button ) -- 1 = Air; 2 = Grass; 3 = Stone; 4 = Dirt; 5 = Wood; 6 = Planks; 7 = Glass; 8 = Leaves
    lovelyMoon.mousepressed(x, y, button)
end

function math.clamp(x, min, max)
  return x < min and min or (x > max and max or x)
end

function love.quit()
end