--Example of a GameState file

--Table
GameState = {}

--New
function GameState:new()
	local gs = {}

	gs = setmetatable(gs, self)
	self.__index = self
	_gs = gs
	
	return gs
end

--Load
function GameState:load()
end

--Close
function GameState:close()
end

--Enable
function GameState:enable()
end

--Disable
function GameState:disable()
end

--Update
function GameState:update(dt)
	xcloud = xcloud + 80 * dt
		
	if xcloud >= 2592 + 192 then
		xcloud = 0 - 192
	end
			
	dt = math.min(dt, 0.07)
	frame = dt * 30

	if guy.y < 32 then --Shove him back!!!!!
		guy.y = 32
	end
    if guy.y > map.height * 32 + 32 then
		guy.y = map.height * 32 + 32
	end
	if guy.x < 1 then
		guy.x = 1
	end
	if guy.x > map.width * 32 then
		guy.x = map.width * 32 --This must be more than his speed forward
	end

	-- Block Breaking Action!
	local x,y = love.mouse.getPosition()
	x = camera:RePositionX(x)
	y = camera:RePositionY(y)
	local mapX = math.floor(y/32)
	local mapY = math.floor(x/32)
	
	if love.mouse.isDown('r') and y > 32 then
		if map[mapX][mapY] - 1 > 0 and blockBreak < 0.8 then
			blockBreak = blockBreak + dt
		elseif blockBreak >= 0.8 then
			for i = 1, 9 do
				if guy.inv[i].tileID == map[mapX][mapY] - 1 then
					if guy.inv[i].count < guy.inv[i].countMax then
						guy.inv[i].count = guy.inv[i].count + 1
						break
					end
				end
			
				if guy.inv[i].tileID == 0 then
					guy.inv[i].tileID = map[mapX][mapY] - 1
					guy.inv[i].count = guy.inv[i].count + 1
					guy.inv[i].typeID = "block"
					break
				end
			end
			
			map[mapX][mapY] = 1
			blockBreak = 0
			
			guy.inv[guy.selected].placeID = guy.inv[guy.selected].tileID + 1
		end
	else
		blockBreak = 0
	end
	-- End of Block Breaking Action!
	
	if (mapCollide(guy.x + 12, guy.y) == 9 or mapCollide(guy.x + 12, guy.y) == 10) and love.keyboard.isDown("w") then
		guy.grav = 0
		guy.ySpeed = -10
	else
		guy.grav = 1.5
	end
		
		
	if guy.direction == 0 then
		ani_guy_r:update(dt)
	elseif guy.direction == 1 then
		ani_guy_l:update(dt)
	end
		
	guy.ySpeed = guy.ySpeed + guy.grav * frame
	guy.y = guy.y + guy.ySpeed * frame
	boundingChecks(guy, map)
		
	--AI for NPCs
	for i,v in ipairs(NCP) do
		v.ySpeed = v.ySpeed + v.grav * frame
		v.y = v.y + v.ySpeed * frame
		NCPboundingChecks(2, v, map)
		
		if v.x > guy.x and v.x < guy.x + 150 and v.x > guy.x + 40 then
			if v.y > guy.y + 10 and v.ySpeed == 0 then
				v.ySpeed = -12
			end
			NCPboundingChecks(1, v, map)
			
		elseif v.x < guy.x and v.x > guy.x - 150 and v.x < guy.x - 40 then
		
			if v.y > guy.y + 10 and v.ySpeed == 0 then
				v.ySpeed = -12
			end
			NCPboundingChecks(0, v, map)
		end
	end
	
	camera:setPosition(guy.x - width / 2, guy.y - height / 2)
end

--Draw
function GameState:draw()
	camera:set()
		
	love.graphics.setColor(40,109,214)
	love.graphics.rectangle('fill',0,0,32 * map.width + 32, 32 * 23)--sky
	love.graphics.setColor(255,255,255)
	
	love.graphics.setColor(39,22,10)
	love.graphics.rectangle('fill',0,21 * 32, 32 * map.width + 32, 32 * 68)--ground
	love.graphics.setColor(255,255,255)
		
	love.graphics.draw(cloud, xcloud - 192, 32)
	
	-- Rendering Magic
	local y_temp =  math.floor(camera:RePositionY(0)/map.tiles.height)
	local y2_temp = ( camera:RePositionY( love.graphics.getHeight() ) / map.tiles.height ) + 1
	local x_temp = math.floor(camera:RePositionX(0)/map.tiles.width)
	local x2_temp = ( camera:RePositionX( love.graphics.getWidth() ) / map.tiles.width ) + 1
		
	if y2_temp > map.height then
		y2_temp = map.height
	end
	
	if x2_temp > map.width then
		x2_temp = map.width
	end
	
	--Draws everything automaticaly
	--Only add extra IFs if the block does something is relation to another block
	for y = y_temp , y2_temp do
		for x = x_temp , x2_temp do
			if map[y][x] == 2 then
				if map[y-1][x] > 1 then
					map[y][x] = 4
				end
			end
			
			if map[y][x] == 4 then
				if map[y-1][x] == 1 and (map[y][x+1] == 2 or map[y][x-1] == 2) then
					map[y][x] = 2
				end
			end
			
			if map[y][x] == 10 then		
				if map[y+1][x] > 1 and ( map[y+1][x] < 10 or map[y+1][x] == 11 ) and map[y][x+1] == 1 then
					map[y][x+1] = 10
				end
				if map[y+1][x] > 1 and ( map[y+1][x] < 10 or map[y+1][x] == 11 ) and map[y][x-1] == 1 then
					map[y][x-1] = 10
				end
				if map[y+1][x] == 1 then
					map[y+1][x] = 10
				end
			end
			
			if map[y][x] == 11 then
				if map[y+1][x] == 1 or map[y+1][x] == 10 then
					map[y+1][x] = 11
					map[y][x] = 1
				end
			end
			
			if map[y][x] == 12 then
				if map[y-1][x] > 1 then
					map[y][x] = 4
				end
			end
			
			if map[y][x] - 1 > 0 then
				love.graphics.draw(tiles[map[y][x] - 1], x * 32, y * 32)
			end
		end
	end
	
	-- Block Breaking Action!
	local x,y = love.mouse.getPosition()
	x = camera:RePositionX(x)
	y = camera:RePositionY(y)
	local mapX = math.floor(y/32)
	local mapY = math.floor(x/32)
	
	if blockBreak > 0 and blockBreak < 0.8 then
		if map[mapX][mapY] - 1 > 0 then
			local vc = 255 - ( 255 * blockBreak )
			love.graphics.setColor(vc, vc, vc)
			love.graphics.draw(tiles[map[mapX][mapY] - 1], mapY * 32, mapX * 32)
			love.graphics.setColor(255, 255, 255)
		end
	end
	-- End of Block Breaking Action!
	
	if guy.direction == 0 then
		ani_guy_r:draw(guy_pic, guy.x, guy.y)
	elseif guy.direction == 1 then
		ani_guy_l:draw(guy_pic_l, guy.x, guy.y)
	end
		
	for i,v in ipairs(NCP) do
		if v.direction == 0 then
			love.graphics.draw(v.pic_r, v.x, v.y)
			love.graphics.print(v.name, v.x, v.y - 18)
		elseif v.direction == 1 then
			love.graphics.draw(v.pic_l, v.x, v.y)
			love.graphics.print(v.name, v.x, v.y - 18)
		end
	end
		
	camera:unset()
	love.graphics.print("FPS:"..love.timer.getFPS().."\nX:"..guy.x.."\nY:"..guy.y, 0, 0)
	
	local centerPos = (love.graphics.getWidth() / 2) - (((9 + 1) * menu:getWidth()) / 2)
	
	for i = 1, 9 do
		love.graphics.draw(menu, centerPos + i * menu:getWidth(), 0)
		if i == guy.selected then
			love.graphics.draw(sel_menu, centerPos + i * sel_menu:getWidth(), 0)
		end
		
		if guy.inv[i].tileID > 0 then
			love.graphics.draw( tiles[guy.inv[i].tileID] , centerPos + i * menu:getWidth() + ((menu:getWidth() - tiles[i]:getWidth()) / 2), 0 + ((menu:getWidth() - tiles[i]:getWidth()) / 2))
			
			love.graphics.print(guy.inv[i].count, centerPos + i * menu:getWidth() + ((menu:getWidth() - tiles[i]:getWidth()) / 2) + 2, 0 + ((menu:getWidth() - tiles[i]:getWidth())) - 2)
		end
	end
end

--KeyPressed
function GameState:keypressed(key, unicode)
	if key == "w" and guy.ySpeed == 0 then
		guy.ySpeed = -16
	end
	
	if key == "1" or key == "2" or key == "3" or key == "4" or key == "5" or key == "6" or key == "7" or key == "8" or key == "9" then
		guy.selected = tonumber(key)
	end
	
	guy.inv[guy.selected].placeID = guy.inv[guy.selected].tileID + 1
end

--KeyReleased
function GameState:keyreleased(key, unicode)
end

--MousePressed
function GameState:mousepressed(x, y, button)
	x = camera:RePositionX(x)
	y = camera:RePositionY(y)
	local mapX = math.floor(y/32)
	local mapY = math.floor(x/32)

	local specialBlockBool = false
	local specialBlockTable = {}
	
	if button == 'l' and y > 32 and ( mapCollide(x, y) < 2 or mapCollide(x, y) == 10 )and ( map[mapX+1][mapY] > 1 or map[mapX-1][mapY] > 1 or map[mapX][mapY+1] > 1 or map[mapX][mapY-1] > 1 ) then
		for i,v in ipairs(specialBlocks) do
			if mapX == v.x and mapY == v.y then
				specialBlockBool = true
				specialBlockTable = v
				break
			end
		end
		
		if specialBlockBool then
			SteamState:openGUI(specialBlockTable)
		else
			if guy.inv[guy.selected].count > 0 and guy.inv[guy.selected].typeID == "block" then
				guy.inv[guy.selected].count = guy.inv[guy.selected].count - 1
				map[mapX][mapY] = guy.inv[guy.selected].placeID
			end
			
			if guy.inv[guy.selected].count <= 0 then
				guy.inv[guy.selected].tileID = 0
				guy.inv[guy.selected].placeID = 0
				guy.inv[guy.selected].typeID = nil
			end
		
			if map[mapX][mapY] == 91 then -- Steam Turbine
				local v = {}
				v.x = mapX
				v.y = mapY
				v.id = "turbine"
				v.steam = 0
				v.steamGen = 50
				v.steamCap = 1000
				v.state = false -- If the block is active or not
			
				table.insert(specialBlocks, v)
			end
		
			--[[if map[mapX][mapY] == 12 then
				local v = {}
				v.x = mapX
				v.y = mapY
				v.id = 12
				v.steam = 0
				v.steamGen = 0
				v.steamCap = 100
			
				table.insert(specialBlocks, v)
			end]]-- Example of a Special Block
		end
	end

	-- Scrolling Feature
	if button == "wu" then
		guy.selected = guy.selected % 9 + 1
	elseif button == "wd" then
		guy.selected = (guy.selected - 2) % 9 + 1
	end
	
	guy.inv[guy.selected].placeID = guy.inv[guy.selected].tileID + 1
end

--MouseReleased
function GameState:mousereleased(x, y, button)
end