--Example of a GameState file

--Table
IntroState = {}

--New
function IntroState:new()
	local gs = {}

	gs = setmetatable(gs, self)
	self.__index = self
	_gs = gs
	
	return gs
end

--Load
function IntroState:load()
	love.graphics.setDefaultImageFilter("nearest","nearest")

	grass = love.graphics.newImage("textures/blocks/grass.png")
	stone = love.graphics.newImage("textures/blocks/stone.png")
	dirt = love.graphics.newImage("textures/blocks/dirt.png")
	grid = love.graphics.newImage("textures/grid.png")
	guy_pic = love.graphics.newImage("textures/player_r.png")
	guy_pic_l = love.graphics.newImage("textures/player_l.png")
	menu = love.graphics.newImage("textures/selected.png")
	sel_menu = love.graphics.newImage("textures/sel_menu.png")
	wood = love.graphics.newImage("textures/blocks/wood.png")
	plank = love.graphics.newImage("textures/blocks/plank.png")
	glass = love.graphics.newImage("textures/blocks/glass.png")
	leaf = love.graphics.newImage("textures/blocks/leaves.png")
	ladder = love.graphics.newImage("textures/blocks/ladder.png")
	water = love.graphics.newImage("textures/blocks/water.png")
	sand = love.graphics.newImage("textures/blocks/sand.png")
	workbenchBlock = love.graphics.newImage("textures/blocks/workbench.png")
	grass_boreal = love.graphics.newImage("textures/blocks/grass_boreal.png")
	
	
	-- Blood Things
	grass_blood = love.graphics.newImage("textures/blocks/grass_blood.png")
	plank_blood = love.graphics.newImage("textures/blocks/plank_blood.png")
	leaves_blood = love.graphics.newImage("textures/blocks/leaves_blood.png")
	
	-- Ores
	ore_iron = love.graphics.newImage("textures/blocks/ore/ore_iron.png")
	ore_tin = love.graphics.newImage("textures/blocks/ore/ore_tin.png")
	ore_copper = love.graphics.newImage("textures/blocks/ore/ore_copper.png")
	ore_gold = love.graphics.newImage("textures/blocks/ore/ore_gold.png")
	ore_crystaltears = love.graphics.newImage("textures/blocks/ore/ore_crystaltears.png")
	ore_avanite = love.graphics.newImage("textures/blocks/ore/ore_avanite.png")
	
	cloud = love.graphics.newImage("textures/cloud.png")--CLOUD
	introscreen = love.graphics.newImage("textures/intro.png")--intro screen
	emblem = love.graphics.newImage("textures/emblem.png")--intro screen
	icon = love.graphics.newImage("textures/icon.png") -- Icon
	
	love.graphics.setIcon(icon)
	width = love.graphics.getWidth()
	height = love.graphics.getHeight()

	guy = { --The table for the player
		x = 32,
		y = 32 * 8,
		ySpeed = 0,
		grav = 1.5,
		width = 30,
		height = 30,
		direction = 0,
		selected = 1,
		inv = {}
	}
		
	for i = 1, 9 do
		guy.inv[i] = {}
		guy.inv[i].tileID = 0 -- ID for drawing the tile
		guy.inv[i].placeID = 0 -- Id for placing the tile
		guy.inv[i].typeID = nil -- If the slot is occupied by a block or an item
		guy.inv[i].count = 0 -- Number of blocks/items in one slot
		guy.inv[i].countMax = 99 -- Maximum number of blocks in one slot
	end
	
	NCP = {}
	
	--Add blocks here (Remember to change the collions)
	tiles = {}
	tiles[1] = grass
	tiles[2] = stone
	tiles[3] = dirt
	tiles[4] = wood
	tiles[5] = plank
	tiles[6] = glass
	tiles[7] = leaf
	tiles[8] = ladder
	tiles[9] = water
	tiles[10] = sand
	tiles[11] = workbenchBlock
	tiles[12] = grass_boreal
	tiles[13] = grass_blood
	tiles[14] = plank_blood
	tiles[15] = leaves_blood
	
	tiles[16] = ore_iron
	tiles[17] = ore_tin
	tiles[18] = ore_copper
	tiles[19] = ore_gold
	tiles[20] = ore_crystaltears
	tiles[21] = ore_avanite
	
	map = {}
	map.tiles = {}
	map.tiles.width, map.tiles.height = 32, 32 --Tiles width and height
	map.tiles.current = 2 -- This is the currently selected tile, the one you put when you click
	map.width = size_of_map_width
	map.height = size_of_map_height
   
    for x = 0, map.height do
		map[x] = {}
		for y = 0, map.width do
			if x < 20 then
				map[x][y] = 1
			
			elseif x < 21 then
				map[x][y] = math.random(1,2)
				
			elseif x < 23 then
				map[x][y] = 2
				GenerateTree(map,x,y)
				GenerateMegaTree(map,x,y)
				GenerateNCP(map,x,y,math.random(1,3),NCP)
				
			else
				map[x][y] = math.random(3,4)
				
			end
	
		if map[x][y] == 4 and map[x-1][y] == 1 and x < 15 then
			map[x][y] = 2
		end
		 
		 --The Great Caves Generation
		if x > 40 and x < 70 and math.random(5) == 1 then
			local oreGen = math.random(200)
			map[x][y] = 1
			
			if oreGen >= 1 and oreGen <= 20 then
				map[x-1][y] = 17 -- Iron
			elseif oreGen >= 20 and oreGen <= 35 then
				map[x-1][y] = 18 -- Tin
			elseif oreGen >= 35 and oreGen <= 45 then
				map[x-1][y] = 19 -- Copper
			elseif oreGen >= 50 and oreGen <= 52 then
				map[x-1][y] = 20 -- Gold
			elseif oreGen >= 60 and oreGen <= 61 then
				map[x-1][y] = 21 -- Crystal Tears
			elseif oreGen >= 90 and oreGen <= 90.5 then
				map[x-1][y] = 22 -- Avanite
			end
			map[x-2][y+1] = 1
			map[x][y-1] = 1
		end
		 
		end
	end
   
	local grid_l = anim8.newGrid(30, 30, guy_pic_l:getWidth(), guy_pic_l:getHeight())
	local grid_r = anim8.newGrid(30, 30, guy_pic:getWidth(), guy_pic:getHeight())
   
	ani_guy_l = anim8.newAnimation('loop', grid_l('1-7,1'), 0.1)
	ani_guy_r = anim8.newAnimation('loop', grid_r('1-7,1'), 0.1)
   
	xcloud = 0
	
	-- Calculates the number of blocks automaticaly
	numBlocks = #tiles + 1
	introd = 0
	
	blockBreak = 0
	specialBlocks = {}
   
	camera:setBounds(0, 0, (map.width * map.tiles.width) - width, (map.height * map.tiles.height) - height)
end

--Close
function IntroState:close()
end

--Enable
function IntroState:enable()
end

--Disable
function IntroState:disable()
end

--Update
function IntroState:update(dt)
	introd = introd + 1 * dt
	if introd >= 2 then
		enableState("menu")
		disableState("intro")
	end
end

--Draw
function IntroState:draw()
	love.graphics.draw( introscreen, 0, 0 )
	love.graphics.draw( emblem, 670 / 2 - 16, 180 )
end

--KeyPressed
function IntroState:keypressed(key, unicode)
end

--KeyRelease
function IntroState:keyrelease(key, unicode)
end

--MousePressed
function IntroState:mousepressed(x, y, button)
end

--MouseReleased
function IntroState:mousereleased(x, y, button)
end

