--Example of a GameState file

--Table
MenuState = {}

--New
function MenuState:new()
	local gs = {}

	gs = setmetatable(gs, self)
	self.__index = self
	_gs = gs
	
	return gs
end

--Load
function MenuState:load()
	menu_bg = love.graphics.newImage("textures/menu_bg.png")
	button = love.graphics.newImage("textures/button.png")
	font = love.graphics.newFont("fonts/badrobot.ttf", 23)
	fonts = love.graphics.newFont(12)
		
	vc1 = 255
	vc2 = 255
end

--Close
function MenuState:close()
end

--Enable
function MenuState:enable()
end

--Disable
function MenuState:disable()
end

--Update
function MenuState:update(dt)
	local x, y = love.mouse.getPosition()
	if x > 335 - (192 / 2) and x < 335 + 96 and y > 200 and y < 264 then--play button
    	vc1 = 0
	elseif x > 335 - (192 / 2) and x < 335 + 96 and y > 280 and y < 344 then
		vc2 = 0
	else
		vc1 = 255
		vc2 = 255
	end
end

--Draw
function MenuState:draw()
	love.graphics.draw(menu_bg,0,0)
	love.graphics.setFont(font)
	
	love.graphics.setColor(255, 255, vc1)--variable colour 1
	love.graphics.draw(button, 335 - (192 / 2), 200)--button1
	love.graphics.print("PLAY", 295, 220)--text1
	
	love.graphics.setColor(255, 255, vc2)--variable colour 2
	love.graphics.draw(button, 335 - (192 / 2), 280)--button2
	love.graphics.print("QUIT", 295, 300)--text2
	
	love.graphics.setFont(fonts)
	love.graphics.setColor(255, 255, 255)
end

--KeyPressed
function MenuState:keypressed(key, unicode)
end

--KeyRelease
function MenuState:keyrelease(key, unicode)
end

--MousePressed
function MenuState:mousepressed(x, y, button)
	if x > 335 - (192 / 2) and x < 335 + 96 and y > 200 and y < 264 then--play button
       enableState("game")
	   enableState("steam")
	   disableState("menu")
	end
	if x > 335 - (192 / 2) and x < 335 + 96 and y > 280 and y < 344 and button == "l" then--quit button
       return love.event.push("quit") or love.event.push("q")
	end
end

--MouseReleased
function MenuState:mousereleased(x, y, button)
end

