--Example of a GameState file

--Table
SteamState = {}

--New
function SteamState:new()
	local gs = {}

	gs = setmetatable(gs, self)
	self.__index = self
	_gs = gs
	
	return gs
end

--Load
function SteamState:load()
	turbine = love.graphics.newImage("textures/blocks/industrial/industrial_steam_turbine.png")
	pipe_0 = love.graphics.newImage("textures/blocks/industrial/industrial_steam_pipe_main.png")
	anvil = love.graphics.newImage("textures/blocks/industrial/anvil.png")
	oven1 = love.graphics.newImage("textures/blocks/industrial/industrial_oven_nofire.png")

    tiles[88] = anvil
	tiles[89] = oven1
    tiles[90] = turbine
	tiles[91] = pipe_0
end

--Update
function SteamState:update(dt)
	turbineGenerate(dt)
end

--Draw
function SteamState:draw()
end

--KeyPressed
function SteamState:keypressed(key, unicode)
end

--MousePressed
function SteamState:mousepressed(x, y, button)
end

function SteamState:openGUI(steamTable)
	-- Applies the changes to the table
	for i,v in ipairs(specialBlocks) do
		if v.x == steamTable.x and v.y == steamTable.y then
			v = steamTable
			break
		end
	end
end

function SteamState:turbineGenerate(dt)
    for i,v in ipairs(specialBlocks) do
		if v.id == "turbine" and v.steam < v.steamCap and v.state then
			v.steam = v.steam + v.steamGen * dt
		end
	end
end

